#include "Polygon.hpp"
#include "Vector.hpp"

#include <dos.h>
#include <stdio.h>
#include <assert.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>

//#define DRAW_DEBUG



//#ifndef BEEP
//#define BEEP(_TONE_)   { sound(_TONE_); delay(200); nosound(); }
//#endif



Polygon& Polygon::operator = (Polygon& pol) {
	point.Clear();
	for(int i=0; i<pol.point.Count(); i++) {
		point.AddNext(pol.point[i]);
	}

	return (*this);
}

// when error, returns NULL
int Polygon::Clip(Segment& seg1, Point2d& point_inside) {
	#ifdef DRAW_DEBUG
	setcolor(RED);
	seg1.Draw();
	#endif

	Vector v_result;
	Point2d p2d_result;
	Segment seg0;

	#define MAX_INTER 5
	Point2d inter_p2d[MAX_INTER];
	int inter_i_seg[MAX_INTER];
	int i_inter=0;

	#ifdef DRAW_DEBUG
	setcolor(WHITE);
	circle(point_inside.x, point_inside.y, 6);
	#endif

	i_inter = 0;

	#ifdef DRAW_DEBUG
	cleardevice(); gotoxy(1,1);
	seg1.Draw();
	Draw();
	#endif

	for(int i=0; i<point.Count(); i++) {
		seg0 = GetSegment(i);
		int is_ok = seg0.Intersect(seg1, &v_result);
		if(is_ok) {
			p2d_result.x = v_result.x+.5;
			p2d_result.y = v_result.y+.5;

			if(seg0.IsInSegment(v_result)) {

				inter_i_seg[i_inter] = i;
				inter_p2d[i_inter] = p2d_result;

				i_inter++;
				if(i_inter >= MAX_INTER) assert(0);  // IMPOSSIBLE. TOO MANY INTERSECTIONS FOUND

				#ifdef DRAW_DEBUG
				setcolor(CYAN);
				circle(p2d_result.x, p2d_result.y,3);
				getch();
				#endif

			}

		}

	}

	if(i_inter==0) return 1; // OK   no intersections

	// identical points are removed from list
	for(i=0; i<i_inter; i++) {
		for(int j=i+1; j<i_inter; j++) {
			if((inter_p2d[i] == inter_p2d[j])
/*			||(inter_p2d[i] == inter_p2d[j]+Point2d(1,0))
			||(inter_p2d[i] == inter_p2d[j]+Point2d(0,1))
			||(inter_p2d[i] == inter_p2d[j]+Point2d(-1,0))
			||(inter_p2d[i] == inter_p2d[j]+Point2d(0,-1))*/) {

				for(int k=j; k<i_inter-1; k++) {
					inter_p2d[k] = inter_p2d[k+1];
					inter_i_seg[k] = inter_i_seg[k+1];
				}
				i_inter--;
			}
		}
	}

	if(i_inter==1) return 1;  // OK   intersecting vertex

	if(i_inter!=2) {
	//  cleardevice();
	//	Print();
	//	printf("i_inter=%i\n", i_inter);
	//	for(int k=0; k<i_inter; k++) {
	//		printf("inter_i_seg[%i] = %i\n", k, inter_i_seg[k]);
	//		printf("inter_p2d[%i]   = ", k);
	//		inter_p2d[k].Print();
	//		printf("\n");
	//	}
	//	setcolor(RED);
	//	seg1.Draw();
	//	Draw();
		return NULL;
	//	getch();
	//	if(i_inter!=1) assert(0);
	}


	#ifdef DRAW_DEBUG
	printf("i_inter=%i\n", i_inter);
	for(int k=0; k<i_inter; k++) {
		printf("inter_i_seg[%i] = %i\n", k, inter_i_seg[k]);
		printf("inter_p2d[%i]   = ", k);
		inter_p2d[k].Print();
		printf("\n");
	}
	#endif


	#ifdef DRAW_DEBUG
	printf("\n");
	point.Print(); printf("\n");
	setcolor(RED);
	Draw();
	getch();
	#endif

	// IF [0] > [1] then swap [0] with [1]
	#define SWAP(A,B,AUX) {(AUX)=(A); (A)=(B); (B)=(AUX);}
	if(inter_i_seg[0] > inter_i_seg[1]) {
		Point2d p_aux;
		SWAP(inter_p2d[0], inter_p2d[1], p_aux);
		int i_aux;
		SWAP(inter_i_seg[0], inter_i_seg[1], i_aux);
	}



	int ind;
	int inc0,inc1;

	// Now the intersection points are added to the polygon.
	// First intersection point is added to the polygon.
	ind = point.IsInArray(inter_p2d[0]);

	inc0 = 1;
	if(ind != -1) {
		// Point 0 found in the polygon
		//BEEP(1000,20);
		inter_i_seg[0] = ind;
		inc0 = 0;
	}
	else {
		inter_i_seg[0] += inc0;
		point.InsertAt(inter_p2d[0], inter_i_seg[0]);
	}

	#ifdef DRAW_DEBUG
	point.Print(); printf("  inter[0]=%i, [1]=%i", inter_i_seg[0], inter_i_seg[1]); printf("\n");
	setcolor(GREEN);
	Draw();
	getch();
	#endif

	// Second intersection point is added to the polygon.
	ind = point.IsInArray(inter_p2d[1]);
	if(ind != -1) {
		// Point 1 found in the polygon
		//BEEP(500,20);
		inter_i_seg[1] = ind;
	}
	else {
		inter_i_seg[1] += 1+inc0;
		point.InsertAt(inter_p2d[1], inter_i_seg[1]);
	}

	#ifdef DRAW_DEBUG
	point.Print(); printf("  inter[0]=%i, [1]=%i", inter_i_seg[0], inter_i_seg[1]); printf("\n");
	setcolor(BLUE);
	Draw();
	getch();
	#endif

	#ifdef DRAW_DEBUG
	setcolor(CYAN);
	circle(point[inter_i_seg[0]].x, point[inter_i_seg[0]].y, 4);
	circle(point[inter_i_seg[1]].x, point[inter_i_seg[1]].y, 4);
	getch();
	#endif

	Segment seg_new(
		Vector(point[inter_i_seg[0]].x, point[inter_i_seg[0]].y,0),
		Vector(point[inter_i_seg[1]].x, point[inter_i_seg[1]].y,0)
	);

	Polygon pol;
	pol.AddPoint(point[inter_i_seg[1]]);
///	pol.seg_list.AddNext(Point2d(i_clipping_seg,0));

	int inc;
	int cant_continue=0;

	// this case prevents from      n_inc = n_dec = 0
	//      when segment [0]-[1]  is convex in the polygon
	if( inter_i_seg[0] == IncIndex(inter_i_seg[1]) ||
		inter_i_seg[0] == DecIndex(inter_i_seg[1]) ) {
		if(inter_i_seg[0]<inter_i_seg[1]) inc = 0;
		else inc = 1;

//		printf("  Consecutives");
		//BEEP(3000,10);
	}
	else {

		switch(WhichSide(seg_new, point_inside, point, inter_i_seg[0], inter_i_seg[1])) {
			case 1:  inc = 1; break;
			case 0:  inc = 0; break;
			case -1: cant_continue = 1; break;
		}
	}

	if(!cant_continue) {

		int index;
		index = inter_i_seg[0];
		while(index!=inter_i_seg[1]) {
			pol.AddPoint(point[index]);
			if(inc) index=IncIndex(index);
			else    index=DecIndex(index);

			#ifdef DRAW_DEBUG
			setcolor(index*2+1);
			pol.Draw();
			getch();
			#endif
		}

		#ifdef DRAW_DEBUG
		setcolor(YELLOW);
		pol.Draw();
		#endif

		if(pol.point.Count() <= 2) return NULL;

		*this = pol;
	}
	else {
		return NULL;
		//printf("Faulty polygon. Ignoring this intersection\n");
		//BEEP(1000,20);
		//getch();
	}

	#ifdef DRAW_DEBUG
	printf("Total points in polygon = %i\n", point.Count());
	Print();
	getch();
	#endif

	return 1; // OK

}

int Polygon::WhichSide(Segment& seg, Point2d& p1, ArrayP2d& ap, int from, int to) {
	int n_inc = 0;
	int n_dec = 0;
	int i;

	for(i=from; i!=to; i=IncIndex(i)) {
		n_inc += seg.AreInSameSide(p1, ap[i]);
	}

	for(i=from; i!=to; i=DecIndex(i)) {
		n_dec += seg.AreInSameSide(p1, ap[i]);
	}


	#ifdef DRAW_DEBUG
	printf("n_inc = %i   n_dec = %i\n", n_inc, n_dec);
	#endif

	if(n_inc==n_dec) {
		//printf("n_inc = %i   n_dec = %i\n", n_inc, n_dec);
		//setcolor(MAGENTA);
		//Draw();
//		getch();
		return -1;   // ERROR!  CAN'T CONTINUE!
//		assert(0);
	}

	if(n_inc>n_dec) {
		//assert(!n_dec);
		return 1;
	}
	//assert(!n_inc);
	return 0;

}


void Polygon::Print(void) {
	for(int i=0; i<point.Count(); i++) point[i].Print();
	printf("\n");
}




#include <conio.h>
#include <stdio.h>
void Polygon::Draw(void) {

	for(int i=0; i<point.Count(); i++) {
		GetSegment(i).Draw();
		#ifdef DRAW_DEBUG
		getch();
		#endif
	}

}


Segment Polygon::GetSegment(int i) {
	if(i<point.Count()-1) {
		return Segment(point[i], point[i+1]);
	}
	else return Segment(point[i], point[0]);
}

int Polygon::IncIndex(int i) {
	if(i<point.Count()-1) return i+1;
	else return 0;
}

int Polygon::DecIndex(int i) {
	if(i==0) return point.Count()-1;
	else return i-1;
}


void Polygon::AddPoint(Point2d& p) {

	point.AddNext(p);
/*
	a_point[point.Count()] = p;
	n_points++;
	if(n_points >= START_POLIGON_POINT_ARRAY_SIZE) {
		BEEP(2000,100);
		#define INCREASE_START_POLIGON_POINT_ARRAY_SIZE NULL
		assert(INCREASE_START_POLIGON_POINT_ARRAY_SIZE);
		//n_points = START_POLIGON_POINT_ARRAY_SIZE-1;
		//return NULL;
	}
*/	//return 1;
}

void Polygon::Fill(void) {
	int y_min;
	int i_y_min;
	int i,y;

	y_min = 30000;
	for(i=0; i<point.Count(); i++) {
		if(point[i].y < y_min) {
			y_min = point[i].y;
			i_y_min = i;
		}
	}


	Segment si;
	Segment sd;
	int y_from, y_to;
	int i_inc, i_dec;

	// init for first pass
	si.p1.x = point[i_y_min].x;
	si.p1.y = point[i_y_min].y;

	i_inc = IncIndex(i_y_min);
	si.p2.x = point[i_inc].x;
	si.p2.y = point[i_inc].y;


	sd.p1.x = point[i_y_min].x;
	sd.p1.y = point[i_y_min].y;

	i_dec = DecIndex(i_y_min);
	sd.p2.x = point[i_dec].x;
	sd.p2.y = point[i_dec].y;

	y_from = y_min;
//	y_to = MIN(si.p2.y, sd.p2.y);

	int next_segment_is_inc;
	int xi, xd;
	int done=0;

	while(!done) {

		done = (i_inc == i_dec);

		if(si.p2.y < sd.p2.y) {
			y_to = si.p2.y;
			next_segment_is_inc = 1;
		}
		else {
			y_to = sd.p2.y;
			next_segment_is_inc = 0;
		}

		// passes
		for(y = y_from; y<y_to; y++) {
			xi = si.p1.x + (si.p2.x-si.p1.x)*(y-si.p1.y)/(si.p2.y-si.p1.y);
			xd = sd.p1.x + (sd.p2.x-sd.p1.x)*(y-sd.p1.y)/(sd.p2.y-sd.p1.y);
			line(xi, y, xd, y);
		}

		if(next_segment_is_inc) {
			i_inc = IncIndex(i_inc);
			si.p1 = si.p2;
			si.p2.x = point[i_inc].x;
			si.p2.y = point[i_inc].y;
		}
		else {
			i_dec = DecIndex(i_dec);
			sd.p1 = sd.p2;
			sd.p2.x = point[i_dec].x;
			sd.p2.y = point[i_dec].y;
		}

		y_from = y_to;

	}

}
