#ifndef __POLYGON__
#define __POLYGON__

#include "Segment.hpp"
#include "Point2d.hpp"
#include "Vector.hpp"

#include <assert.h>
#include <dos.h>
#include <stdio.h>
#include "ArrayP2d.hpp"

#define START_POLIGON_POINT_ARRAY_SIZE   20
#define INCREMENT_POLIGON_POINT_ARRAY_SIZE 5

#define BEEP(TONE,DELAY)   { sound(TONE); delay(DELAY); nosound(); }


class Polygon {
	public:

		ArrayP2d   point;

	public:

		Polygon(void) : point(START_POLIGON_POINT_ARRAY_SIZE,
							  INCREMENT_POLIGON_POINT_ARRAY_SIZE,
							  "Polygon.point") {}

		~Polygon() { }

		Polygon& operator = (Polygon& pol);
		void AddPoint(Point2d& p);
		void Clear(void) { point.Clear();}
		int Clip(Segment& seg, Point2d& point_inside);
		void Draw(void);
		void Fill(void);
		void Print(void);

		int  IncIndex(int i);
		int  DecIndex(int i);

	private:
		Segment GetSegment(int i);
		int WhichSide(Segment& seg, Point2d& p1, ArrayP2d& ap, int from, int to);
		int IsPointInThePolygon(ArrayP2d& ap, Point2d& p);

};

#endif