/* ͻ
	   Vector.hpp        Versin 1.2, Octubre 1.995  
	                                                 
	   Definicin de la clase Vector.                
	                                                 
	   (C) Alvaro Silgado Herrero.                   
	 ͼ */

#ifndef __VECTOR__
#define __VECTOR__

//#include "Matrix33.hpp"

#include <stdio.h>

#define EPSILON   1e-3
#define ABS(x) ((x) >= 0 ? (x) : (-(x)))



class Vector {
	public:

		float x,y,z;

	public:
		Vector(void);
		Vector(float cx, float cy, float cz);
		~Vector() {}

		Vector operator = (Vector & v);
		Vector operator = (float n);
		Vector operator + (Vector & v);
		Vector operator + (float n);
		Vector operator - ();
		Vector operator - (Vector & v);
		Vector operator - (float n);
		Vector operator * (Vector & v);
		Vector operator * (float n);
		Vector operator / (float n);
		Vector operator / (Vector & v);
		int    operator > (float n);
		float  operator | (Vector & v);
		Vector operator & (Vector & v);
		Vector operator ! ();
		void como_mucho (float r);
		int  dominante ();
		int  alguno_positivo ();
		float mod(void);
		void normaliza(void);
		int operator == (const Vector& v);
		void Print(void) { printf("(%f,%f,%f)", x,y,z); }


};

#endif
